﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;

namespace WebApplication1
{
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class MyService
    {
        [OperationContract]
        public IEnumerable<Dictionary<string, object>> GetData(string query)
        {
            var table = GetDataTable(query);

            var columns = table.Columns.Cast<DataColumn>();

            return table.AsEnumerable().Select(r => columns.Select(c =>
                                 new { Column = c.ColumnName, Value = r[c] })
                             .ToDictionary(i => i.Column, i => i.Value != DBNull.Value ? i.Value : null));
        }

        public DataTable GetDataTable(string query)
        {
            var connString = ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString;
            var conn = new SqlConnection(connString);
            var adapter = new SqlDataAdapter();
            adapter.SelectCommand = new SqlCommand(query, conn);

            var table = new DataTable();

            conn.Open();
            try
            {
                adapter.Fill(table);
            }
            finally
            {
                conn.Close();
            }

            return table;
        }
    }
}
